#include <avr/io.h>
#include "uart.h"

void uart_init(void) {
	UBRRH = UBRR_VAL >> 8;
	UBRRL = UBRR_VAL & 0xFF;
	
	UCSRB |= (1<<TXEN);  // UART TX einschalten
	UCSRC = (1<<URSEL)|(1<<UCSZ1)|(1<<UCSZ0);  // Asynchron 8N1
}

void uart_sendChar(unsigned char c) {
	while (!(UCSRA & (1<<UDRE))) {  /* warten bis Senden moeglich */
	}

	UDR = c;                      /* sende Zeichen */
	return 0;
}


/* puts ist unabhaengig vom Controllertyp */
void uart_sendString (char *s) {
	while (*s) {   /* so lange *s != '\0' also ungleich dem "String-Endezeichen(Terminator)" */
		uart_sendChar(*s);
		s++;
	}
}

void uart_sendInt(unsigned char c) {
	unsigned char buffer[3];
	
	itoa(c, buffer, 10);
	
	uart_sendString(buffer);
}

void uart_newLine(void) {
	uart_sendChar(13);
	uart_sendChar(10);
}